using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;
using System.Xml;
using System.Xml.Serialization;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;

namespace GGC_XML
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupingControl1;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Button button2;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridGroupingControl1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.button1 = new System.Windows.Forms.Button();
			this.button2 = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridGroupingControl1
			// 
			this.gridGroupingControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
			this.gridGroupingControl1.Location = new System.Drawing.Point(16, 56);
			this.gridGroupingControl1.Name = "gridGroupingControl1";
			this.gridGroupingControl1.Size = new System.Drawing.Size(448, 336);
			this.gridGroupingControl1.TabIndex = 0;
			this.gridGroupingControl1.Text = "gridGroupingControl1";
			this.gridGroupingControl1.VersionInfo = "3.301.0.0";
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(216, 16);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(128, 23);
			this.button1.TabIndex = 1;
			this.button1.Text = "Write Visible Grid";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// button2
			// 
			this.button2.Location = new System.Drawing.Point(352, 16);
			this.button2.Name = "button2";
			this.button2.Size = new System.Drawing.Size(104, 23);
			this.button2.TabIndex = 2;
			this.button2.Text = "Expand All";
			this.button2.Click += new System.EventHandler(this.button2_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(480, 422);
			this.Controls.Add(this.button2);
			this.Controls.Add(this.button1);
			this.Controls.Add(this.gridGroupingControl1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			DataSet ds = new DataSet();
			DataTable dt = new DataTable("MyTable");

			int nCols = 4;
			int nRows = 20;
			Random r = new Random(123345345);

			for(int i = 0; i < nCols; i++)
				dt.Columns.Add(new DataColumn(string.Format("Col{0}", i), typeof(int)));

			for(int i = 0; i < nRows; ++i)
			{
				DataRow dr = dt.NewRow();
				for(int j = 0; j < nCols; j++)
					dr[j] = r.Next(10);
				dt.Rows.Add(dr);
			}

			ds.Tables.Add(dt);  
			this.gridGroupingControl1.DataSource = dt;
			ds.WriteXml("sss.xml");   

			this.gridGroupingControl1.ShowGroupDropArea = true;

			this.gridGroupingControl1.TableDescriptor.Columns[0].Appearance.AnyRecordFieldCell.CellType = "GridListControl";     
			this.gridGroupingControl1.TableDescriptor.Columns[0].Appearance.AnyRecordFieldCell.DataSource = dt;
			this.gridGroupingControl1.TableDescriptor.Columns[0].Appearance.AnyRecordFieldCell.ValueMember = "Col1";

			this.gridGroupingControl1.TableControlCurrentCellShowingDropDown +=new GridTableControlCurrentCellShowingDropDownEventHandler(gridGroupingControl1_TableControlCurrentCellShowingDropDown);  

		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			string name = @"temp.xml";
			XmlTextWriter xw = new XmlTextWriter(name, System.Text.Encoding.Default);
			xw.Formatting = Formatting.Indented;
			WriteXml(this.gridGroupingControl1, xw);
			xw.Close();
		}

		private void button2_Click(object sender, System.EventArgs e)
		{
			this.gridGroupingControl1.Table.ExpandAllGroups();
		}

		#region Write Visible Grid.
		private void WriteXml(GridGroupingControl grid, XmlTextWriter xw)
		{
			xw.WriteStartElement("GridGroupingControl");
			 

			foreach(Element el in grid.Table.DisplayElements)
			{
				if(el is GridRecordRow)
					WriteGridRecordRow(el as GridRecordRow, xw);
				else if(el is GridCaptionRow)
					WriteGridCaptionRow(el as GridCaptionRow, xw);
			}

			xw.WriteEndElement();

		}

		private void WriteGridRecordRow(GridRecordRow grr, XmlTextWriter xw)
		{
			xw.WriteStartElement("Record");
			foreach(FieldDescriptor fd in grr.ParentTableDescriptor.Fields)
			{
				if(grr.GetRecord() is GridRecord)
				xw.WriteElementString(fd.Name, grr.GetRecord().GetValue(fd).ToString());
			}
			xw.WriteEndElement();
		}

		private void WriteGridCaptionRow(GridCaptionRow gcr, XmlTextWriter xw)
		{
			xw.WriteStartElement("Caption");
			string s = gcr.ParentGroup.Category == null ? "" : gcr.ParentGroup.Category.ToString();
			xw.WriteElementString(gcr.ParentGroup.Name, s);
			 
			xw.WriteEndElement();
		}

		private void button3_Click(object sender, System.EventArgs e)
		{
			
		}
		#endregion

		private void gridGroupingControl1_TableControlCurrentCellShowingDropDown(object sender, GridTableControlCurrentCellShowingDropDownEventArgs e)
		{
			GridCurrentCell cc = e.TableControl.CurrentCell;
			if( cc.ColIndex == 1 && cc.RowIndex == 5)
			{
				GridDropDownGridListControlCellRenderer cr =  cc.Renderer as GridDropDownGridListControlCellRenderer; 
				if( cr != null)
					cr.ListControlPart.ShowColumnHeader = false; 
			}
		}
	}
}
